﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcTempDemo1.Models;

namespace MvcTempDemo1.Controllers {
    [HandleError]
    public class EmployeeController : Controller {   
        [HttpGet]
        public ActionResult Index(EmployeeModel model) {
           
            if (model.Offices == null) {
                model.Offices = ModelData.OfficeData;
            }
           
            
            return View(model);
        }

        [HttpPost]
        public ActionResult Details(EmployeeModel model) {
            if (ModelState.IsValid) {
                //TODO This should be replaced by a infrastructure service such as a database
                if (model.Offices != null) {
                    var offices = new List<Office>();
                    //Get offices by OfficeId that where selected 
                    foreach (var office in model.Offices) {
                        offices.Add(   
                                        ModelData
                                        .OfficeData
                                        .Single(o => o.OfficeId == office.OfficeId)
                                    );
                    }
                    model.Offices = offices;
                }
                //
                
                return View(model);
            }
            else {
                return RedirectToAction("Index", model);
            }
        }
    }
}
