﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using MvcTempDemo1.Binders;

namespace MvcTempDemo1.Models
{
    //TODO This should be replaced by a infrastructure service such as a database
    public static class ModelData {
        public static List<Office> OfficeData = new List<Office>(new Office[]{ 
                                                new Office{ OfficeId = new Guid("ee70f79e-3840-4e8f-98eb-aa8ee12e254c"), Address = "One Microsoft Way, Redmond", Country = "United States", PostalCode = "WA 98052" },
                                                new Office{ OfficeId = new Guid("0780b91a-7000-4860-a89c-ed6a1ea6c071"), Address = "Microsoft Campus, Thames Valley Park, Reading, Berkshire", Country = "United Kingdom", PostalCode = "RG6 1WG" },
                                                new Office{ OfficeId = new Guid("db7a5076-c7c7-42f3-a6c6-1ead82af310a"), Address = "Centro Direzionale San Felice, Palazzo A. Via Rivoltana, 13", Country = "Italy", PostalCode = "1320090 Segrate (MI)" }  
                                            }
                                        );

    }

    [ModelBinder(typeof(EmployeeBinder))]
    public class EmployeeModel {
        [Required]
        [DisplayName("First Name")]
        public string FirstName { get; set; }
        
        [Required]
        [DisplayName("Last Name")]
        public string LastName { get; set; }
        
        [DisplayName("Date of Birth")]
        public DateTime? DateOfBirth { get; set; }

        [Required]
        [DataType("Offices")]
        public List<Office> Offices { get; set; }
    }

    public class Office {
        public Guid OfficeId { get; set; }
        public string Country { get; set; }
        public string Address { get; set; }
        public string PostalCode { get; set; }
    }
}